

function rabbitOnDestroy()
{
	var name = GetCurrentPerson();
	var index;
	for (var i = 0; i < rabbits.length; i++)
	{
		if (rabbits[i] == name) index = i; break;
	}
	rabbits.splice(index,1);
}
function rabbitOnIdle()
{
	if (paused) return ;
	var name = GetCurrentPerson();
	var data = GetPersonData(name);
	var courage = data["courage"];
	var health = data["health"];
	if (health <= 0)
	{
		killPerson(name);
	}
	else
	{
		var hprop = data["health"] / data["maxhealth"];
		//var fear = data["fear"];
		var speed = data["speed"];
		var backup = rabbits.length;
		this.retreat = false;
		if (hprop < 0.50) {this.retreat = true;}
		var x = GetPersonX(name);
		var y = GetPersonY(name);
		var gforce = gfield(x,y).scale(1-hprop);//.scale(fear);
		var pforce = pfield(x,y).scale(courage*hprop);
		var rforce = rfield(x,y).scale(1-hprop);
		var force = vadd(gforce, pforce);
		if (this.retreat) force = vadd(force, rforce);
		if (gforce.len() == 0 && pforce.len() == 0) force= rfield(x,y);
		run(force.dir(), speed);
	}
}
function run(direction, speed)
{
	//day = direction;
	var name = GetCurrentPerson();
	var x = GetPersonX(name);
	var y = GetPersonY(name);
	var stepx = x;
	var stepy = y;
	if (Math.cos(direction) > 0) stepx ++; else stepx --;
	if (Math.sin(direction) > 0) stepy ++; else stepy--;
	var newx = Math.round(x + speed * Math.cos(direction));
	var newy = Math.round(y + speed * Math.sin(direction));
	//1. Check if stepx, stepy is blocked by plant. if so, eat.
	//2. Else, if stepx, stepy is close to hole, and health is low, escape.
	//3. else move.
	//QueuePersonCommand(name, COMMAND_FACE_EAST, true)
	if (isPlant(GetObstructingTile(name, stepx, stepy)))
	{
		SetPersonFrame(name, 0);
		//var ep = getPlant(stepx, stepy);
		
		eatPlant(stepx, stepy);
	}
	else if (this.retreat && getHole(stepx, stepy) != "")
	{
		DestroyPerson(name);
	}
	else
	{
		
		var diffx = x - newx; if (diffx < 0) diffx *= -1;
		var diffy = y - newy; if (diffy < 0) diffy *= -1;
		var moved = false;
		var block;
		//var spritedir = GetPersonDirection(name);
		for (var i = 0; i < diffy; i++)
		{
			if (y < newy)
			{
				QueuePersonCommand(name, COMMAND_FACE_SOUTH, true);
				moved = movedown(name) || moved;
				if (!moved) 
				{
					block = GetObstructingPerson(name, GetPersonX(name), GetPersonY(name)+1);
					break;
				}
			}
			else
			{
				QueuePersonCommand(name, COMMAND_FACE_NORTH, true);
				moved = moveup(name) || moved;
				if (!moved) 
				{
					block = GetObstructingPerson(name, GetPersonX(name), GetPersonY(name)-1);
					break;
				}
			}
		}
		if (block != "")
		{
			for (var i = 0; i < diffx; i++)
			{
				if (x < newx) 
				{
					QueuePersonCommand(name, COMMAND_FACE_EAST, true);
					moved = moveright(name) || moved;
					if (!moved) 
					{
						block = GetObstructingPerson(name, GetPersonX(name) + 1, GetPersonY(name));
						break;
					}
				}
				else
				{
					QueuePersonCommand(name, COMMAND_FACE_WEST, true);
					moved = moveleft(name) || moved;
					if (!moved) 
					{
						block = GetObstructingPerson(name, GetPersonX(name) - 1, GetPersonY(name));
						break;
					}
				}
			}
		}
		if (!moved)
		{
			SetPersonFrame(name,0);
		}
		if (block != "")
		{
			for (var i = 0; i < bullets.length; i++)
			{
				if (bullets[i] == block)
				{
					hitPerson(name, GetPersonValue(bullets[i], "power"));
					DestroyPerson(bullets[i]);
					break;
				}
			}
		}
		
		var newdir;
		/*
		switch (spritedir)
		{
			case "north": newdir = COMMAND_FACE_NORTH; break;
			case "northeast": newdir = COMMAND_FACE_NORTHEAST; break;
			case "east": newdir = COMMAND_FACE_EAST; break;
			case "southeast": newdir = COMMAND_FACE_SOUTHEAST; break;
			case "south": newdir = COMMAND_FACE_SOUTH; break;
			case "southwest": newdir = COMMAND_FACE_SOUTHWEST; break;
			case "west" : newdir = COMMAND_FACE_WEST; break;
			case "northwest": newdir = COMMAND_FACE_NORTHWEST; break;
			default: newdir = COMMAND_IDLE
		}*/
		newdir = COMMAND_WAIT;
		var list = GetPersonList();
		for (var i = 0; i < list.length; i++)
		{
			if (name == list[i])
			{
				QueuePersonCommand(name, newdir, false);
				break;
			}
		}
		//QueuePersonCommand(name, newdir, false);
	}
}
function getHole(x,y)
{
	var a = x ;
	//day = x;
	var b = y ;
	for (var i = 0; i < holes.length; i++)
	{
		if (holes[i].x - a <= 65 && holes[i].x - a >= -65 && holes[i].y - b <= 65 && holes[i].y-b >= -65)
		{
			//var font = GetSystemFont();
			//font.draText(15,35,"a");
			return plants[i];
		}
	}
	return "";
}
function gfield(x,y)
{
	var gx = GetPersonX("Granny");
	var gy = GetPersonY("Granny");
	//var diff = new Vector (x-gx, y-gy);
	var font = GetSystemFont();
	//day = x-gx;
	var gscary = GetPersonValue("Granny", "scariness");
	var magnitude = gscary/dist(x-gx,y-gy);
	var direction = Math.atan2(x-gx,y-gy);
	//day = direction;
	return polarV(magnitude, direction);
	//return new Vector(1,0);
}
function pfield(x,y)
{
	var tempx = 0;
	var tempy = 0;
	for (var i = 0; i < plants.length; i++)
	{
		var p = plants[i];
		var diff = new Vector (p.x - x, p.y - y);
		var magnitude = 1.0 / diff.len();
		var direction = diff.dir();
		tempx += magnitude * Math.cos(direction);
		tempy += magnitude * Math.sin(direction);
	}
	var tempv = new Vector (tempx, tempy);
	return tempv;
}
function rfield(x,y)
{
	var tempx = 0;
	var tempy = 0;
	for (var i = 0 ; i < holes.length; i++)
	{
		var h = holes[i];
		var diff = new Vector (h.x - x, h.y - y);
		var magnitude = 40* Math.max(1.0/diff.len(), 0.02);
		var direction = diff.dir();
		tempx += magnitude * Math.cos(direction);
		tempy += magnitude * Math.sin(direction);
	}
	var tempv = new Vector(tempx, tempy);
	return tempv;
}
function hitPerson(name, power)
{
	var olddata = GetPersonData(name);
	var oldhealth = olddata["health"];
	var newhealth = oldhealth-power;
	olddata["health"] = oldhealth - power;
	SetPersonData(name, olddata);
	if (newhealth <= 0)
	{
		killPerson(name);
	}
}
function eatPlant(x, y)
{
	//x -= (x % 50);
	//y -= (y % 50);
	//var font = GetSysFont();
	if (getPlant(x,y) != "")
	{
		hitPlant(getPlant(x,y),0.05);
	}
	else
	{
		//b()
	}
}
function deathscript(deathlength)
{
	var name = GetCurrentPerson();
	if (GetPersonFrame(name) == deathlength)
	{
		if (name != "Granny")
		{
			DestroyPerson(name); //Put score here
		}
		else
		{
			killGranny();
		}
	}
	else QueuePersonScript(name, "deathscript()", false);
}
function killPerson(name) //Note to self: play death animation, then destroy. In that order. How? check for last frame on update.
{
	if (GetPersonDirection(name) != "dying")
	{
		//SetPersonDirection(name,"dying");
		ClearPersonCommands(name);
		//var ss = GetPersonSpriteset(name);
		//var ssdir = ss.directions[directions.length - 1]; //HAAAACK
		//if (name == "Granny") DetachInput();
		//QueuePersonScript(name, "deathscript(ssdir.frames.length)", false);
		DestroyPerson(name);
	}
}