EvaluateScript("bullet.js");
EvaluateScript("vector.js");
EvaluateScript("rabbit.js");
EvaluateScript("control.js");
EvaluateSystemScript("timer.js");
EvaluateScript("plant.js");
EvaluateScript("trigger.js");
EvaluateScript("update.js");


//EvaluateScript("incidents.js"); //TODO scenario loader.
//Global Arrays
var bullets;
var rabbits;
var plants;
var holes;
//Global variable
var score;
var paused;
//var gscary; //how much granny scares the rabbits
var advance;
var stamina;
var maxstam;
var numrabbits;
var numbullets;
var HUD1;
var HUD2;
var timer;
var gunsound;
function game()
{
	score = 0;
	numbullets = 0;
	numrabbits = 0;
	gunsound = LoadSound("shotgun2.mp3");
	advance = false;
	paused= false;
	Intro();
	SetFrameRate(60);
  //BindKey(KEY_UP, "flagmoveup()", "unflagmoveup()"); //experiment with keybinds more later to alter charspeed
	//MapEngine("Day"+i+".rmp", 60);
	//MapEngine("map.rmp",60);
	
	CreatePerson("Granny", "Granny1.rss", false);
	SetPersonValue("Granny", "scariness", 1);
	day = 1;
	//cutscene(i);
	//SetPersonScript("Granny", SCRIPT_COMMAND_GENERATOR, "standstill()");
	//SetPersonFrameRevert("Granny", 0)
	AttachInput("Granny");
	initializeControl();
	AttachCamera("Granny");
	stamina = 100;
	maxstam = 100;
	numevents = 0;
	numframes = 0;
	bullets = []; //names of persons
	rabbits = []; //names of persons
	plants = [];  //names of custom objects
	holes = [];
	SetRenderScript("timecheck(); if (!paused) movePlayer(); renderHUD();");
	HUD1 = CreateSurface(800, 75, CreateColor(0,0,0, 50));
	
	HUD2 = CreateSurface(800, 75, CreateColor(0,0,0,50));
	numevents = 0;
	timer = new Timer();
	MapEngine("Garden.rmp", 60);
		
  
  //Note to self: advancement between days etc. is called in the update file; character speech is in incidents.
}
function standstill(name)
{
	//var name = GetCurrentPerson();
	SetPersonFrame(name, 0);
}
function Hole(x,y)
{
	this.x = x;
	this.y = y;
}
function makeHole(x,y)
{
	x -= x % 50;
	y -= y % 50;
	SetTile(x/50,y/50,1,50);
	holes.push(new Hole(x+25,y+25));
}
//Make Functions
function makeRabbit(x,y, maxhealth,courage, speed)
{
	var name = "rabbit" + (numrabbits++);
	CreatePerson(name, "Rabbit.rss", true);
	rabbits.push(name);
	//SetPersonScript(name, SCRIPT_ON_CREATE, "rabbitOnCreate()");
	SetPersonScript(name, SCRIPT_ON_DESTROY, "rabbitOnDestroy()"); //score.
	SetPersonScript(name, SCRIPT_COMMAND_GENERATOR, "rabbitOnIdle()");
	SetPersonIgnoreList(name, ["Granny"]);
	var data = GetPersonData(name);	//Note to self: make proper accessor functions later
	data["maxhealth"] = maxhealth;
	data["health"] = maxhealth;
	data["courage"] = courage;
	data["speed"] = speed;
	//data["fear"] = fear;
	SetPersonData(name, data);
	SetPersonX(name,x);
	SetPersonY(name, y);
}
function Intro()
{
	Rectangle(0,0,800,600, CreateColor(0,0,255));
	var image = LoadImage("StudioMomo.png");
	image.zoomBlit(120,130,2);
	FlipScreen();
	GetKey();
	image = LoadImage("splashpage copy.png");
	//FlipScreen();
	var exit = false;
	var item = 0;
	//image.blit(0,0);
	//var selectsurface = CreateSurface(800,600,CreateColor(0,0,0,0));
	while (!exit)
	{
		image.blit(0,0);
		//selectsurface.rectangle(0,0,800,600,CreateColor(0,0,0,0));
		switch(item)
		{
			case 0:
				OutlinedRectangle(210, 315, 610-210, 390-315, CreateColor(255,0,0,80), 5); break;
			case 1:
				OutlinedRectangle(190, 400, 640-190, 460-400, CreateColor(255,0,0,80), 5); break;
			case 2:
				OutlinedRectangle(410, 525, 675-410, 585-525, CreateColor(255,0,0,80), 5); break;
		}
		
		//selectsurface.blit(0,0);
		FlipScreen();
		var key = GetKey();
		if (key == KEY_DOWN)
		{
			item++; if (item > 2) item = 0;
		}
		else if (key == KEY_UP)
		{
			item--; if (item < 0) item = 2;
		}
		else if (key == KEY_ENTER)
		{
			switch (item)
			{
				case 0:
					exit = true; break;
				case 1:
					//print instructions.
					var font = GetSystemFont();
					font.drawZoomedText(0,0,2,"Arrowkeys to walk");
					font.drawZoomedText(0,100,1.5,"Hold shift to run (while stamina is left)");
					font.drawZoomedText(0,200,2, "Press any key to continue;");
					FlipScreen();
					GetKey();
					break;
				case 2:
					var credits = LoadImage("Credits.png");
					credits.blit(0,0);
					FlipScreen();
					GetKey(); break;
			}
		}
	}
}
function makeBullet(x,y,dir,spd,pow) //dir is radians
{
	var name = "bullet" + (numbullets++);
	CreatePerson(name, "Bullet.rss", true);
	bullets.push(name);
	SetPersonAngle(name,dir);
	SetPersonLayer(name, 1);
	//SetPersonScript(name, SCRIPT_ON_CREATE, "bulletOnCreate();");
	SetPersonScript(name, SCRIPT_ON_DESTROY, "bulletOnDestroy();");
	SetPersonScript(name, SCRIPT_COMMAND_GENERATOR, "bulletOnIdle()"); //fly
	var data = GetPersonData(name);
	data["power"] = pow;
	data["speed"] = spd;
	SetPersonData(name, data);
	SetPersonX(name,x);
	SetPersonY(name,y);
}

//Is tile a plant?
function isPlant(index)
{
	if (index == -1) return false;
	var plantnames = ["tomato", "potato", "carrot", "cabbage", "weed"];
	var name = GetTileName(index);
	for (var i = 0; i < plantnames.length; i++)
	{
		if (name == plantnames[i])
		{
			//day = 3;
			return true;
		}
	}
	return false;
}